#6 Please add file dates and sizes for tracked files in the reports

v1.9 series
closed
M. Buecher
None
1
2013-04-04
2013-02-01
Enod Barker
No

Regshot from 1.8.x to the current 1.9.0 betas (excepting r260 which crashed here and you fixed) has been great. An excellent replacement for Inctrl5. That install tracker has massive problems with crashing recording Windows 7 registry changes. It will show you the file changes OK, but only the registry changes about 10% of the time you run it. It worked fine in Windows XP & prior. Regshot is also far superior to the modern Inctrl5 replacement Inctrl X. Because for some ill advised reason, that version can no longer do two-phase install compares like 5 and Regshot can do.

With one major exception. In Inctrl5's reports under Files added: & Files deleted:, it has lines under each file showing you both the full Date: and Size:. For example:
c:\Program Files\SomeProgram\Folder2\somefile.dll
Date: 12/11/2012 12:58 PM
Size: 43,272 bytes

Even better, under Files changed:, it shows you the old & new dates and sizes for every file changed. For example:
c:\Documents and Settings\All Users\SomeProgram\somefile.log
Old date: 12/19/2012 2:28 PM
New date: 12/19/2012 3:11 PM
Old size: 36,622 bytes
New size: 53,992 bytes

That's incredibly useful. Can see at a glance when uninstalling if you need to do anything with changed files or not. Also see if files with new dates have changed in size or not, which can possibly indicate if those changed files are actually any different from the old. Finally, can quickly correlate those file dates/sizes with manifests of a particular program's file versions.

Regshot doesn't do this; it doesn't add dates or sizes to any files it records. As a result, for informative reports its necessary to run both Inctrl5 (for file tracking) and Regshot (for registry tracking). In fact, if Inctrl5 didn't fail to record Windows 7's registry properly, I wouldn't be using Regshot at all.

So hopefully Regshot can record and show in its reports dates and sizes of files like Inctrl5 does. And, if you want to go further, extract file versions from executable files to add as well (if it doesn't add substantial time to the recording). Hopefully by the time 1.9.0 goes full release.

Thanks.

Discussion

  • M. Buecher
    M. Buecher
    2013-02-01

    File sizes and change dates are already retrieved during shots and also stored in hive files.
    So it is just a matter of adding them to the output.

    But that's also the reason why it will be scheduled after 1.9.0 release.
    We want to coordinate the change with the undoreg author.
    Additionally a single line output (<file>|<date>|<size>) and ISO formats (yyyy-mm-dd 24:00) are preferred.

    File versions will require extra coding.
    If limiting to .exe and .dll then performance hit may not be huge.
    Could be made optional.

    Thanks for your request.
    The Regshot Team

     
    Last edit: M. Buecher 2013-02-01
  • M. Buecher
    M. Buecher
    2013-02-01

    • status: open --> accepted
    • assigned_to: M. Buecher
     
  • Enod Barker
    Enod Barker
    2013-02-08

    Thanks very much for considering this!

    With that change, Regshot will become a 100% replacement for Inctrl5. Not to mention the major advantages that showing file dates/times will give to advanced users who have no experience with that program.

    A bit unfortunate that you won't be able to get it into the next full release. But I (and I'm sure many others) look very forward to seeing the feature in future versions. Hope you can coordinate it OK with the Undoreg author (I never use that program; I do changes manually...heh).

    As to details, I'm not totally convinced that putting the date/time data in one line is preferred to how Inctrl does it (multi-line). Because if you have a very long file path (for example: "c:\Program Files\MozillaFirefoxProfiles\profilename\extensions{q3w8v54b-f6ed-450b-b12d-ee082ba88573}\modules\third-party\someextension.js"), adding the changes onto the end of that line will often make it necessary to use word wrap in an editor.

    And when its wrapped, the data/times will look messy and not line up properly in the editor, potentially making things difficult to read. Unlike what happens with multi-line additions; they are always neat and easy to read, despite taking up a bit more visual space.

    File versions, on the other hand, are not totally essential. As you say, it may introduce a performance hit (Regshot right now is super-fast), thus having it as a selectable option in the program may be advised.

    Just brought it up as Windows provides easy API access to EXE (and DLL) versions, so would be another advantage for advanced users.

    Thanks again for your consideration and look I forward to future Regshot versions!

     
  • M. Buecher
    M. Buecher
    2013-02-09

    For humans the single line output is more difficult to read, but it allows for easier parsing the output file.
    If you know *nix systems than it is like grep'ing single lines vs. sed'ing blocks.
    But will keep this in mind when discussing.

    Next release is planned to be released at least until 2013-06-30.
    It was important to release working x64 and Unicode builds with 1.9.0.
    Will keep you informed about betas that implement the requested feature.

    P.S.:
    About performance: nice to hear that it feels fast for you. we spent quite some time to reduce time consumption.
    Still saving, comparing and output has to be optimized further. Especially saving is very slow on virtual machines (here Virtual Box), but using a mem buffer should speed this up tremendously. Just if you are interested in Regshot's code.

     
  • M. Buecher
    M. Buecher
    2013-03-06

    Just recognized that extra file data is no issue for UndoReg as these data are not related to the registry. Sometimes you can be very blind.

     
  • M. Buecher
    M. Buecher
    2013-03-09

    • status: accepted --> closed
     
  • M. Buecher
    M. Buecher
    2013-03-09

    Committed in [r301].
    Get development snapshot from files section.

     

    Related

    Commit: [r301]

  • M. Buecher
    M. Buecher
    2013-04-04

    Final solution in new beta 1.9.1 [r313]

     

    Related

    Commit: [r313]